REM http://prdownloads.sourceforge.net/libpng/libpng-1.6.3.tar.gz

set P=libpng
set V=1.6.29
set B=1

set ARCH=%1

if "%ARCH%"=="x86" (
	set OSGEO4W_ROOT=C:\OSGeo4W
	set VCARCH=x86
	set CMAKEGEN=Visual Studio 14 2015
	set ZLIB_LIBRARY=C:\OSGeo4W\lib\zlib.lib
) else if "%ARCH%"=="x86_64" (
	set OSGEO4W_ROOT=C:\OSGeo4W64
	set VCARCH=x64
	set CMAKEGEN=Visual Studio 14 2015 Win64
	set ZLIB_LIBRARY=C:\OSGeo4W64\lib\zdll.lib
) else (
	echo unexpected arch & goto error
)

set R=..\..\..\%ARCH%\release\%P%
mkdir %R%

call %OSGEO4W_ROOT%\bin\o4w_env.bat

set pf=%ProgramFiles(x86)%
if "%pf%"=="" set pf=%ProgramFiles%
call "%pf%\Microsoft Visual Studio 14.0\VC\vcvarsall.bat" x64
echo on
path C:\Program Files\CMake\bin;%pf%\Microsoft Visual Studio 14.0\Common7\IDE;%PATH%;c:\cygwin\bin

set I=%CD:\=/%

mkdir build-%ARCH%
mkdir install-%ARCH%
cd build-%ARCH%

cmake -G "%CMAKEGEN%" ^
	-D PNG_STATIC=FALSE ^
	-D CMAKE_INSTALL_PREFIX=../install-%ARCH%/libs/vc14 ^
        -D ZLIB_INCLUDE_DIR=%OSGEO4W_ROOT:\=/%/include ^
        -D ZLIB_LIBRARY=%ZLIB_LIBRARY:\=/% ^
	../..
if errorlevel 1 (echo cmake error & goto error)

devenv %P%.sln /Project ALL_BUILD /Build Release
if errorlevel 1 (echo build error & goto error)

devenv %P%.sln /Project INSTALL /Build Release
if errorlevel 1 (echo install error & goto error)

cd ..

mkdir install-%ARCH%\bin
move install-%ARCH%\libs\vc14\bin\libpng16.dll install-%ARCH%\bin

copy setup.hint %R%\setup.hint
copy ..\LICENSE %R%\%P%-%V%-%B%.txt

tar -cjf %R%\%P%-%V%-%B%.tar.bz2 lib bin include
tar -C .. -cjf %R%\%P%-%V%-%B%-src.tar.bz2 osgeo4w/package.cmd osgeo4w/setup.hint osgeo4w/build.sh

copy setup.hint %R%
copy ..\LICENSE %R%\%P%-%V%-%B%.txt

tar -C install-%ARCH% -cjf %R:\=/%/%P%-%V%-%B%.tar.bz2 bin
if errorlevel 1 (echo tar pkg error & goto error)

tar -C install-%ARCH% -cjf %R:\=/%/%P%-devel/%P%-%V%-%B%.tar.bz2 libs
if errorlevel 1 (echo tar devel error & goto error)

tar -C .. -cjf %R:\=/%/%P%-%V%-%B%-src.tar.bz2 osgeo4w/package.cmd osgeo4w/setup.hint 
if errorlevel 1 (echo tar src error & goto error)

exit

:error
